#include <stdio.h>
#include <stdlib.h>
#include <LEDA/stream.h>
#include <iostream.h>
#include <LEDA/graph.h>
#include <LEDA/graphwin.h>
#include <LEDA/node_array.h>
#include <LEDA/point.h>
#include <LEDA/random_source.h>

using namespace leda;

#define SIZE 500

void copy(double dist[SIZE][SIZE],double redist[SIZE][SIZE],int n);
void display(double dist[SIZE][SIZE],int n);
void R(double dist[SIZE][SIZE], double r[SIZE], int n);
void M_DIST(double dist[SIZE][SIZE], double M[SIZE][SIZE], double r[SIZE], int n, int num,int a[SIZE],int c);
void min_ij(double dist[SIZE][SIZE],int n,int *x, int *y);
void r_dist(double dist[SIZE][SIZE],double redist[SIZE][SIZE],int n, int min_i, int min_j,int a[SIZE],int c);
void last_node(int last[SIZE],int a[SIZE], int n);

int main(int argc, char *argv[]){
  FILE *fin,*in;
  double dist[SIZE][SIZE],M[SIZE][SIZE],redist[SIZE][SIZE];
  double r[SIZE];
  double S[SIZE];
  int du[SIZE],last[2];
  int i,j,index;
  int min_i,min_j;
  int n,a=0,num;
  char label_node[20];
  random_source s,s1;
  
  if((fin=fopen(argv[1],"r"))==NULL)
    printf("File open error\n");
  
  fscanf(fin,"%d",&n);
  num=n;
  
  for(i=0;i<n;i++){
    for(j=0;j<n;j++){
      dist[i][i]=0;
    }
  }
  for(i=0;i<n+1;i++)
    du[SIZE]=1000;
  
  for(i=0;i<n;i++){
    for(j=i+1;j<n;j++){
      fscanf(fin,"%lf",&dist[i][j]);
    }
  }
  
  GRAPH<point,double>G;
  
  array<node>v(SIZE);     // ΡɷΥǡǼ
  //array<edge>e(SIZE);
  
  for(i=0; i<n; i++){
    v[i]=G.new_node();
  }
  index = i;
  
  display(dist,n);
  
  for(i=0;i<n-1;i++){
    if(i<n-2){
    R(dist,r,index);
    M_DIST(dist,M,r,index,num,du,a);
    min_ij(M,index,&min_i,&min_j);

    du[a]=min_i;
    a++;
    du[a]=min_j;
    a++;
    /*
    for(j=0; j<n; j++)
    printf("%d ",du[j]);
    putchar('\n');
    */

    S[min_i]=(dist[min_i][min_j]/2) + ((r[min_i]-r[min_j]) / (2*(num-2)));
    S[min_j]=dist[min_i][min_j]-S[min_i];
    printf("dist[%d][%d]=%.3f\n",min_i,min_j,dist[min_i][min_j]);
    printf("r[%d]=%.3f r[%d]=%.3f\n",min_i,r[min_i],min_j,r[min_j]);
    printf("S[%d]=%.3f S[%d]=%.3f\n\n", min_i, S[min_i], min_j, S[min_j]);
    
    v[index] = G.new_node();
    edge eg;
    eg=G.new_edge(v[index],v[min_i],S[min_i]);
    eg=G.new_edge(v[index],v[min_j],S[min_j]);
    
    r_dist(dist,redist,index,min_i,min_j,du,a);
    num--;
    index++;
    }else{
      last_node(last,du,index);
      edge eg;
      eg=G.new_edge(v[last[0]],v[last[1]],dist[last[0]][last[1]]);
      break;
    }
  }
  printf("%d",n);

  //դ
  GraphWin gw(G,800,800,"nj");
  gw.set_node_label_font(roman_font,8); //եȥ
  gw.set_node_color(green); //Ρɿ
  gw.set_edge_direction(undirected_edge); //դμ
  gw.set_edge_color(red);//դο

  s.set_range(350,470);
  s1.set_range(10,340);

  if((in=fopen(argv[2],"r"))==NULL)
    exit(1);

  for(i=0; i<n; i++){
    fscanf(in,"%s",&label_node);
    gw.set_label(v[i],label_node);
    gw.set_color(v[i],color(258,128,0));
    gw.set_radius1(v[i],11);
    point p(s1(),s1());
    gw.set_position(v[i],p);
    gw.set_width(v[i],60);
    gw.set_shape(v[i],rectangle_node);
    gw.set_height(v[i],25);
  }

  for(i=n; i<index; i++){
    gw.set_label_type(v[i], no_label);
    gw.set_radius1(v[i], 3);
    point p(s(),s());
    gw.set_position(v[i], p);
  }

  gw.open();
  fclose(fin);
  fclose(in);
  return 0;
  
}

//distredist˥ԡ
void copy(double dist[SIZE][SIZE],double redist[SIZE][SIZE],int n){
  int i,j;
  for(i=0;i<n;i++){
    for(j=0;j<n;j++){
      redist[i][j]=dist[i][j];
    }
  }
}

//ɽ
void display(double dist[SIZE][SIZE],int n){
  int i,j;
  for(i=0;i<=n-1;i++){
    
    for(j=0;j<=n-1;j++){
      printf(" %2.3f",dist[i][j]);
    }
    printf("\n");
  }
}

//r(i)η׻
void R(double dist[SIZE][SIZE], double r[SIZE], int n){
  int i,j;
  
  for(i=0;i<n;i++){
    r[i]=0;
  }
  
  for(i=0;i<n;i++){
    for(j=0;j<n;j++){
      if(i<j){
	r[i]+=dist[i][j];
	//printf("i=%d j=%d dist=%.3f r=%.3f\n",i,j,dist[i][j],r[i]);
      }else if(i==j){
	r[i]+=0;
	//printf("i=%d j=%d dist=%.3f r=%.3f\n",i,j,dist[i][j],r[i]);
      }else{
	r[i]+=dist[j][i];
       	//printf("i=%d j=%d dist=%.3f r=%.3f\n",i,j,dist[j][i],r[i]);
      }
    }
     printf("r[%d]=%.3f ",i,r[i]);
  }
  printf("\n\n");
}

//M(ij)η׻
void M_DIST(double dist[SIZE][SIZE], double M[SIZE][SIZE], double r[SIZE], int n, int num,int a[SIZE],int c){
  
  int i,j,k,flag;

  for(i=0;i<n;i++){
    for(j=0;j<n;j++){
      M[i][j]=0;
    }
  }

  for(i=0;i<n;i++){
    for(j=i+1;j<n;j++){
      for(k=0; k<c; k++){
	if(i==a[k] || j== a[k]){
	  flag=1;
	  break;
	}
	else
	  flag=0;
      }
      if(flag==1)
	M[i][j]=0;
      else
	M[i][j]=dist[i][j]-(r[i]+r[j])/(num-2);
      //printf("i=%d j=%d p=%d r1=%.3f r2=%.3f M=%.3f\n",i,j,p, r[i], r[j], M[i][j]);
    }
  }
  display(M,n);
}


//ǾȤʤڥM(ij)
void min_ij(double M[SIZE][SIZE],int n,int *x,int *y){
  int i,j;
  double min;
  
  min=100;
  for(i=0;i<n;i++){
    for(j=i+1;j<n;j++){
      if(M[i][j]!=0 && min>M[i][j]){
	min=M[i][j];
	*x=i; *y=j;
	printf("i=%d j=%d min=%.3f\n",i,j,min);
      }
    }
  }
}


//Υɽι
void r_dist(double dist[SIZE][SIZE],double redist[SIZE][SIZE], int n, int min_i, int min_j,int a[SIZE],int c){
  int i,j,k,flag;
  
  copy(dist,redist,n);
  /*
    display(redist,n);
  printf("\n");
  */

  for(i=0;i<n+1;i++){
    for(j=i+1;j<n+1;j++){
      for(k=0; k<c; k++){
	if(i==a[k] || j== a[k]){
	  flag=1;
	  break;
	}
	else
	  flag=0;
      }
      if(flag==1){
	redist[i][j]=0;
      }else if(j==n && flag==0){
	if(min_i>i && min_j>i)
	  redist[i][j]=(dist[i][min_i]+dist[i][min_j]-dist[min_i][min_j])/2;
	else if(min_i>i && i>min_j)
	  redist[i][j]=(dist[i][min_i]+dist[min_j][i]-dist[min_i][min_j])/2;
	else if(i>min_i && min_j>i)
	  redist[i][j]=(dist[min_i][i]+dist[i][min_j]-dist[min_i][min_j])/2;
	else if(i>min_i && i>min_j)
	  redist[i][j]=(dist[min_i][i]+dist[min_j][i]-dist[min_i][min_j])/2;
      }
    }
  }

  copy(redist,dist,n+1);
  display(dist,n+1);

}

//ĤĤ
void last_node(int last[SIZE],int a[SIZE], int n){
  int i,j,flag,c=0;

  for(i=0;i<n;i++){
    for(j=0;j<n+1;j++){
      if(i==a[j]){
	flag=1;
	break;
      }else
	flag=0;
    }
    if(flag==0){
      last[c]=i;
      c++;
    }
  }
}

